# SNAC Documentation

This repository contains all the documentation for the SNAC Web Application and related frameworks, engines, and pieces.

## Table of Contents

* [Technology Infrastructure Architecture Overview](Overview.md)
* [Overall Tech Plan Document](Plan.md) (draft)
* Requirements and Specifications
    * [Requirements](Requirements): The currently-being-revised Technical Requirements  
    * [Specifications](Specifications): Formal Specifications for the Technical Requirements
* Discussion and Documentation
    * [Database Schema Diagrams](http://shannonvm.village.virginia.edu/~twl8n/schema_spy_output/)
    * [Third Party Documentation](Third Party Documentation): Documentation on third-party software and applications being used
    * [Historical Documentation](Historical Documentation): Documentation on previous iterations of SNAC
    * [Technical Discussions](Discussion): Technical discussions related to the SNAC project
    * [Notes](Notes): Notes from the technical team.
* [Help](Help): Help on using Gitlab, Git, and the Markdown text format

## Notes on this Repository

This repository is stored in Gitlab, a work-alike clone of the Github web site, but installed locally on a SNAC server. Gitlab is a
version control system with a suite of project management tools.

Ideally we will all create documentation in [markdown format](http://daringfireball.net/projects/markdown/) (.md files). You may create and edit files from
the web interface here on Gitlab, or download files and edit locally. You can also upload any file type using
standard git commands, or use a Git graphical client (see below). Choose a relevant directory for your docs,
or create a new directory as necessary.  

Markdown files are simple text files, which makes them easy to edit and universally portable. Markdown has a
limited set of conventions to denote headers, lists, URLs and so on. When uploaded to gitlab or github,
markdown files are rendered into nicely styled HTML. Tools are available to convert markdown into .doc, .pdf,
LaTex and other formats. For more information on Markdown, see [this guide](Help/Markdown.md).


#### Help Links

* [Git and Gitlab](Help/Git-and-Gitlab.md)
* [Markdown](Help/Markdown.md)

<p xmlns:dct="http://purl.org/dc/terms/" xmlns:vcard="http://www.w3.org/2001/vcard-rdf/3.0#" align="center">
  <a rel="license"
     href="http://creativecommons.org/publicdomain/zero/1.0/">
    <img src="http://i.creativecommons.org/p/zero/1.0/88x31.png" style="border-style: none;" alt="CC0" />
  </a>
  <br />
  To the extent possible under law,
  <span resource="[_:publisher]" rel="dct:publisher">
    <span property="dct:title">SNAC Cooperative</span></span>
  has waived all copyright and related or neighboring rights to
  <span property="dct:title">SNAC Documentation</span>.
This work is published from:
<span property="vcard:Country" datatype="dct:ISO3166"
      content="US" about="[_:publisher]">
  United States</span>.
</p>
